var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { mapToCssModules, tagPropType } from './Shared/helper.js';
//import { Bar, Doughnut, Line, Pie, Polar, Radar } from 'react-chartjs-2';

//component - CoreUI / CCharts

var CCharts = function CCharts(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      type = props.type,
      data = props.data,
      options = props.options,
      attributes = _objectWithoutProperties(props, ['children', 'className', 'cssModule', 'innerRef', 'type', 'data', 'options']);

  var set = {
    line: Line,
    bar: Bar,
    doughnut: Doughnut,
    pie: Pie,
    polar: Polar,
    radar: Radar
  };

  var Chart = set[type];

  // render

  var classes = mapToCssModules(classNames(className, 'c-chart-wrapper'), cssModule);

  return React.createElement(
    'div',
    { className: classes },
    React.createElement(Chart, _extends({}, attributes, { data: data, options: options, ref: innerRef }))
  );
};

CCharts.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  data: PropTypes.object,
  options: PropTypes.object,
  type: PropTypes.oneOf(['line', 'bar', 'doughnut', 'pie', 'polar', 'radar'])
} : {};

CCharts.defaultProps = {
  type: 'line'
};

export default CCharts;