var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import CHeaderNavLink from './CHeaderNavLink';

//component - CoreUI / CHeaderNavItem

var CHeaderNavItem = function CHeaderNavItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      to = props.to,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'custom', 'innerRef', 'to', 'linkClassName', 'linkProps']);

  //render

  var classes = mapToCssModules(classNames(className, 'c-header-nav-item'), cssModule);

  if (!custom) {
    return React.createElement(
      Tag,
      _extends({}, attributes, { className: classes, ref: innerRef }),
      React.createElement(CHeaderNavLink, _extends({}, linkProps, { className: linkClassName, to: to, children: children }))
    );
  }

  return React.createElement(Tag, _extends({}, attributes, { className: classes, children: children, ref: innerRef }));
};

CHeaderNavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  custom: PropTypes.bool,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  to: PropTypes.string,
  linkClassName: PropTypes.string,
  linkProps: PropTypes.object
} : {};

CHeaderNavItem.defaultProps = {
  tag: 'li'
};

export default CHeaderNavItem;