'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CCarouselIndicators

var CCarouselIndicators = function CCarouselIndicators(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      items = props.items,
      activeIndex = props.activeIndex,
      onClickHandler = props.onClickHandler,
      itemProps = props.itemProps,
      attributes = _objectWithoutProperties(props, ['className', 'cssModule', 'innerRef', 'items', 'activeIndex', 'onClickHandler', 'itemProps']);

  //render

  var listClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'carousel-indicators'), cssModule);

  var indicators = items.map(function (item, idx) {
    var indicatorClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)({ 'active': activeIndex === idx }), cssModule);
    return _react2.default.createElement('li', _extends({
      key: '' + (item.key || Object.values(item).join('')),
      onClick: function onClick(e) {
        e.preventDefault();
        onClickHandler(idx);
      },
      className: indicatorClasses
    }, itemProps));
  });

  return _react2.default.createElement(
    'ol',
    _extends({}, attributes, { className: listClasses, ref: innerRef }),
    indicators
  );
};

CCarouselIndicators.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  items: _propTypes2.default.array.isRequired,
  activeIndex: _propTypes2.default.number.isRequired,
  onClickHandler: _propTypes2.default.func.isRequired,
  itemProps: _propTypes2.default.object
} : {};

exports.default = CCarouselIndicators;
module.exports = exports['default'];