'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _reactPopper = require('react-popper');

var _CDropdownCustom = require('./CDropdownCustom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CDropdownMenu

var CDropdownMenu = function CDropdownMenu(props) {
  var className = props.className,
      cssModule = props.cssModule,
      right = props.right,
      tag = props.tag,
      flip = props.flip,
      modifiers = props.modifiers,
      persist = props.persist,
      innerRef = props.innerRef,
      attributes = _objectWithoutProperties(props, ['className', 'cssModule', 'right', 'tag', 'flip', 'modifiers', 'persist', 'innerRef']);

  var noFlipModifier = { flip: { enabled: false } };

  var directionPositionMap = {
    up: 'top',
    left: 'left',
    right: 'right',
    down: 'bottom'
  };

  var context = (0, _react.useContext)(_CDropdownCustom.Context);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'dropdown-menu', {
    'dropdown-menu-right': right,
    'show': context.isOpen
  }), cssModule);

  var Tag = tag;

  if (persist || context.isOpen && !context.inNavbar) {
    Tag = _reactPopper.Popper;
    var position1 = directionPositionMap[context.direction] || 'bottom';
    var position2 = right ? 'end' : 'start';
    attributes.placement = position1 + '-' + position2;
    attributes.component = tag;
    attributes.modifiers = !flip ? _extends({}, modifiers, noFlipModifier) : modifiers;
  }

  return _react2.default.createElement(Tag, _extends({
    tabIndex: '-1',
    role: 'menu'
  }, attributes, {
    'aria-hidden': !context.isOpen,
    className: classes,
    'x-placement': attributes.placement,
    ref: innerRef
  }));
};

CDropdownMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  right: _propTypes2.default.bool,
  flip: _propTypes2.default.bool,
  modifiers: _propTypes2.default.object,
  persist: _propTypes2.default.bool
} : {};

CDropdownMenu.defaultProps = {
  tag: 'div',
  flip: true
};

exports.default = CDropdownMenu;
module.exports = exports['default'];