'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _reactTransitionGroup = require('react-transition-group');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CFade

var CFade = function CFade(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      children = props.children,
      innerRef = props.innerRef,
      baseClass = props.baseClass,
      baseClassActive = props.baseClassActive,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'children', 'innerRef', 'baseClass', 'baseClassActive']);

  //render

  var transitionProps = (0, _helper.pick)(attributes, _helper.TransitionPropTypeKeys);
  var childProps = (0, _helper.omit)(attributes, _helper.TransitionPropTypeKeys);

  return _react2.default.createElement(
    _reactTransitionGroup.Transition,
    transitionProps,
    function (status) {
      var isActive = status === 'entered';
      var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, baseClass, isActive && baseClassActive), cssModule);
      return _react2.default.createElement(
        Tag,
        _extends({ className: classes }, childProps, { ref: innerRef }),
        children
      );
    }
  );
};

CFade.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, _reactTransitionGroup.Transition.propTypes, {
  tag: _helper.tagPropType,
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]),
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  baseClass: _propTypes2.default.string,
  baseClassActive: _propTypes2.default.string
}) : {};

CFade.defaultProps = _extends({}, _reactTransitionGroup.Transition.defaultProps, {
  tag: 'div',
  //
  baseClass: 'fade',
  baseClassActive: 'show',
  timeout: _helper.TransitionTimeouts.Fade,
  appear: true,
  enter: true,
  exit: true,
  in: true
});

exports.default = CFade;
module.exports = exports['default'];