'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CIconRaw = require('./CIconRaw');

var _CIconRaw2 = _interopRequireDefault(_CIconRaw);

var _CIconModule = require('./CIcon.module.css');

var _CIconModule2 = _interopRequireDefault(_CIconModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CIcon

var CIcon = function CIcon(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      name = props.name,
      size = props.size,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'name', 'size']);

  //render

  var type = 'svg';

  if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) == 'object') {
    switch (name.type) {
      case 'class':
        type = 'class';
        break;
      default:
    }
  }

  if (type == 'svg') {
    return _react2.default.createElement(_CIconRaw2.default, _extends({}, attributes, { name: name, size: size, className: className }));
  }

  var classes = (0, _classnames2.default)((0, _helper.mapToCssModules)(className, Object.assign(_CIconModule2.default, cssModule)), type == 'name' ? name : type == 'class' ? name.className : null, size ? 'c-icon-' + size : null);

  return _react2.default.createElement(Tag, _extends({}, attributes, { className: classes }));
};

CIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  name: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string]),
  size: _propTypes2.default.string
} : {};

CIcon.defaultProps = {
  tag: 'i'
};

exports.default = CIcon;
module.exports = exports['default'];