'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CListGroup

var CListGroup = function CListGroup(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      horizontal = props.horizontal,
      flush = props.flush,
      variant = props.variant,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'innerRef', 'horizontal', 'flush', 'variant']);

  // render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'list-group', horizontal ? 'list-group-horizontal-' + horizontal : false, flush ? 'list-group-flush' : false, variant ? 'list-group-' + variant : false), cssModule);

  return _react2.default.createElement(Tag, _extends({}, attributes, { className: classes, ref: innerRef }));
};

CListGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  flush: _propTypes2.default.bool,
  horizontal: _propTypes2.default.string,
  role: _propTypes2.default.string,
  variant: _propTypes2.default.string
} : {};

CListGroup.defaultProps = {
  tag: 'ul',
  role: 'list-items'
};

exports.default = CListGroup;
module.exports = exports['default'];