'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CMedia = require('./CMedia');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CMediaAside

var CMediaAside = function CMediaAside(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      asideImageProps = props.asideImageProps,
      asideVerticalPosition = props.asideVerticalPosition,
      asideRight = props.asideRight,
      addAsideMargin = props.addAsideMargin,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'innerRef', 'asideImageProps', 'asideVerticalPosition', 'asideRight', 'addAsideMargin']);

  var computedAsideImageProps = function computedAsideImageProps() {
    return Object.assign({
      placeholderColor: '#777777',
      width: '64px',
      height: asideVerticalPosition === 'stretch' ? '100%' : '64px'
    }, asideImageProps || {});
  };

  var context = (0, _react.useContext)(_CMedia.Context);

  if (!asideRight && context.asideRight) asideRight = true;

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, addAsideMargin ? 'm' + (asideRight ? 'l' : 'r') + '-3' : '', 'align-self-' + asideVerticalPosition), cssModule);

  return _react2.default.createElement(Tag, _extends({}, attributes, { className: classes, ref: innerRef }));
};

CMediaAside.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  asideVerticalPosition: _propTypes2.default.string,
  asideRight: _propTypes2.default.bool,
  asideImageProps: _propTypes2.default.object,
  addAsideMargin: _propTypes2.default.bool
} : {};

CMediaAside.defaultProps = {
  tag: 'div',
  asideVerticalPosition: 'start'
};

exports.default = CMediaAside;
module.exports = exports['default'];