'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CModalHeader

var CModalHeader = function CModalHeader(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      toggle = props.toggle,
      WrapTag = props.wrapTag,
      closeAriaLabel = props.closeAriaLabel,
      charCode = props.charCode,
      close = props.close,
      mainClassName = props.mainClassName,
      mainProps = props.mainProps,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'innerRef', 'toggle', 'wrapTag', 'closeAriaLabel', 'charCode', 'close', 'mainClassName', 'mainProps']);

  //render

  var closeButton = void 0;

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'modal-header'), cssModule);

  var mainClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)(mainClassName, 'modal-title'), cssModule);

  if (!close && toggle) {
    var closeIcon = typeof charCode === 'number' ? String.fromCharCode(charCode) : charCode;
    closeButton = _react2.default.createElement(
      'button',
      { type: 'button', onClick: toggle, className: (0, _helper.mapToCssModules)('close', cssModule), 'aria-label': closeAriaLabel },
      _react2.default.createElement(
        'span',
        { 'aria-hidden': 'true' },
        closeIcon
      )
    );
  }

  return _react2.default.createElement(
    WrapTag,
    _extends({}, attributes, { className: classes, ref: innerRef }),
    _react2.default.createElement(
      Tag,
      _extends({ className: mainClasses }, mainProps),
      children
    ),
    close || closeButton
  );
};

CModalHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  wrapTag: _helper.tagPropType,
  toggle: _propTypes2.default.func,
  closeAriaLabel: _propTypes2.default.string,
  charCode: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  close: _propTypes2.default.object,
  mainClassName: _propTypes2.default.string,
  mainProps: _propTypes2.default.object
} : {};

CModalHeader.defaultProps = {
  tag: 'h5',
  wrapTag: 'div',
  closeAriaLabel: 'Close',
  charCode: 215
};

exports.default = CModalHeader;
module.exports = exports['default'];