'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CPagination = require('./CPagination');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CPaginationLink

var CPaginationLink = function CPaginationLink(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      next = props.next,
      previous = props.previous,
      onClick = props.onClick,
      type = props.type,
      n = props.n,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'innerRef', 'next', 'previous', 'onClick', 'type', 'n']);

  var context = (0, _react.useContext)(_CPagination.Context);

  var linkClick = function linkClick(e) {
    onClick && onClick(e, type, n);
    context.paginationClick && context.paginationClick(e, type, n);
  };

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'page-link'), cssModule);

  var defaultAriaLabel = void 0;
  if (previous) {
    defaultAriaLabel = 'Previous';
  } else if (next) {
    defaultAriaLabel = 'Next';
  }
  var ariaLabel = props['aria-label'] || defaultAriaLabel;

  var defaultCaret = void 0;
  if (previous) {
    defaultCaret = _react2.default.createElement(
      _react2.default.Fragment,
      null,
      '\u2039'
    );
  } else if (next) {
    defaultCaret = _react2.default.createElement(
      _react2.default.Fragment,
      null,
      '\u203A'
    );
  }

  var children = props.children;

  if (children && Array.isArray(children) && children.length === 0) {
    children = null;
  }

  if (!attributes.href && Tag === 'a') {
    Tag = 'button';
  }

  if (previous || next) {
    children = [_react2.default.createElement(
      'span',
      {
        'aria-hidden': 'true',
        key: 'caret'
      },
      children || defaultCaret
    ), _react2.default.createElement(
      'span',
      {
        className: 'sr-only',
        key: 'sr'
      },
      ariaLabel
    )];
  }

  return _react2.default.createElement(
    Tag,
    _extends({}, attributes, {
      className: classes,
      onClick: linkClick,
      'aria-label': ariaLabel,
      ref: innerRef
    }),
    children
  );
};

CPaginationLink.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  next: _propTypes2.default.bool,
  type: _propTypes2.default.string,
  n: _propTypes2.default.number,
  previous: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  'aria-label': _propTypes2.default.string
} : {};

CPaginationLink.defaultProps = {
  tag: 'a'
};

exports.default = CPaginationLink;
module.exports = exports['default'];