'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _CSidebarNavLink = require('./CSidebarNavLink');

var _CSidebarNavLink2 = _interopRequireDefault(_CSidebarNavLink);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CSidebarNavItem

var CSidebarNavItem = function CSidebarNavItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      custom = props.custom,
      innerRef = props.innerRef,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      icon = props.icon,
      to = props.to,
      badge = props.badge,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'custom', 'innerRef', 'linkClassName', 'linkProps', 'icon', 'to', 'badge']);

  var link = _extends({}, linkProps);

  //render

  var classes = (0, _classnames2.default)(className, 'c-sidebar-nav-item');

  var linkClasses = (0, _classnames2.default)(linkClassName);

  !link && (link = {});
  icon && (link.icon = icon);
  to && (link.to = to);
  badge && (link.badgeProps = badge);

  return !custom ? _react2.default.createElement(
    Tag,
    _extends({ className: classes }, attributes, { ref: innerRef }),
    _react2.default.createElement(_CSidebarNavLink2.default, _extends({ className: linkClasses }, link, { children: children }))
  ) : _react2.default.createElement(Tag, _extends({ className: classes }, attributes, { ref: innerRef, children: children }));
};

CSidebarNavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  custom: _propTypes2.default.bool,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  linkClassName: _propTypes2.default.string,
  linkProps: _propTypes2.default.object,
  ///
  icon: _propTypes2.default.oneOfType(['string', 'object']),
  badge: _propTypes2.default.object
} : {};

CSidebarNavItem.defaultProps = {
  tag: 'li'
};

exports.default = CSidebarNavItem;
module.exports = exports['default'];