'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CTable

var CTable = function CTable(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      size = props.size,
      bordered = props.bordered,
      borderless = props.borderless,
      striped = props.striped,
      dark = props.dark,
      hover = props.hover,
      responsive = props.responsive,
      ResponsiveTag = props.responsiveTag,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'custom', 'innerRef', 'size', 'bordered', 'borderless', 'striped', 'dark', 'hover', 'responsive', 'responsiveTag']);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'table', size ? 'table-' + size : false, bordered ? 'table-bordered' : false, borderless ? 'table-borderless' : false, striped ? 'table-striped' : false, dark ? 'table-dark' : false, hover ? 'table-hover' : false), cssModule);

  var table = void 0;
  if (custom) table = _react2.default.createElement(Tag, _extends({}, attributes, { className: classes }));else {
    table = _react2.default.createElement(
      Tag,
      _extends({}, attributes, { className: classes }),
      _react2.default.createElement(
        'tbody',
        null,
        attributes.children
      )
    );
  }

  if (responsive) {
    var responsiveClassName = responsive === true ? 'table-responsive' : 'table-responsive-' + responsive;
    return _react2.default.createElement(
      ResponsiveTag,
      { className: responsiveClassName, ref: innerRef },
      table
    );
  }

  return table;
};

CTable.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  custom: _propTypes2.default.bool,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string, _propTypes2.default.object]),
  size: _propTypes2.default.string,
  bordered: _propTypes2.default.bool,
  borderless: _propTypes2.default.bool,
  striped: _propTypes2.default.bool,
  dark: _propTypes2.default.bool,
  hover: _propTypes2.default.bool,
  responsive: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string]),
  responsiveTag: _helper.tagPropType
} : {};

CTable.defaultProps = {
  tag: 'table',
  responsiveTag: 'div'
};

exports.default = CTable;
module.exports = exports['default'];