'use strict';

exports.__esModule = true;

var _ref;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CCard = require('./CCard');

var _CCard2 = _interopRequireDefault(_CCard);

var _CCardBody = require('./CCardBody');

var _CCardBody2 = _interopRequireDefault(_CCardBody);

var _CCardFooter = require('./CCardFooter');

var _CCardFooter2 = _interopRequireDefault(_CCardFooter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
//

//import CProgress from './CProgress';

//import CCardHeader from './CCardHeader';


//component - CoreUI / CWidgetIcon

var CWidgetIcon = function CWidgetIcon(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      header = props.header,
      mainText = props.mainText,
      icon = props.icon,
      color = props.color,
      footer = props.footer,
      link = props.link,
      variant = props.variant,
      attributes = _objectWithoutProperties(props, ['children', 'className', 'cssModule', 'header', 'mainText', 'icon', 'color', 'footer', 'link', 'variant']);

  var padding = variant === '0' ? { card: 'p-3', icon: 'p-3' } : variant === '1' ? {
    card: 'p-0', icon: 'p-4', lead: 'pt-3'
  } : { card: 'p-0', icon: 'p-4 px-5', lead: 'pt-3' };

  var card = { style: 'd-flex', color: color, icon: icon, classes: '' };
  card.classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, card.style, padding.card, 'align-items-center'), cssModule);

  var lead = { style: 'text-value', color: color, classes: '' };
  lead.classes = (0, _classnames2.default)(lead.style, 'text-' + card.color);

  var blockIcon = function blockIcon(icon) {
    var classes = (0, _classnames2.default)(icon, 'bg-' + card.color, padding.icon, 'font-2xl mr-3 float-left');
    return _react2.default.createElement('i', { className: classes });
  };

  var cardFooter = function cardFooter() {
    if (footer) {
      return _react2.default.createElement(
        _CCardFooter2.default,
        { className: 'px-3 py-2' },
        _react2.default.createElement(
          'a',
          { className: 'align-items-center btn-block d-flex justify-content-between text-muted', href: link },
          _react2.default.createElement(
            'span',
            { className: 'small font-weight-bold' },
            'View More'
          ),
          _react2.default.createElement('i', { className: 'fa fa-angle-right float-right font-lg' })
        )
      );
    }
  };

  return _react2.default.createElement(
    _CCard2.default,
    _extends({}, attributes, { custom: true }),
    _react2.default.createElement(
      _CCardBody2.default,
      _extends({ className: card.classes }, attributes),
      _react2.default.createElement(
        'div',
        null,
        blockIcon(card.icon)
      ),
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: lead.classes },
          header
        ),
        _react2.default.createElement(
          'div',
          { className: 'text-muted text-uppercase font-weight-bold small' },
          mainText
        )
      )
    ),
    cardFooter()
  );
};

CWidgetIcon.propTypes = process.env.NODE_ENV !== "production" ? (_ref = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  header: _propTypes2.default.string,
  mainText: _propTypes2.default.string,
  icon: _propTypes2.default.string,
  color: _propTypes2.default.string,
  variant: _propTypes2.default.string,
  footer: _propTypes2.default.bool,
  link: _propTypes2.default.string
}, _ref['children'] = _propTypes2.default.node, _ref) : {};

CWidgetIcon.defaultProps = {
  header: '$1,999.50',
  mainText: 'Widget title',
  icon: 'fa fa-cogs',
  color: 'primary',
  variant: '0',
  link: '#'
};

exports.default = CWidgetIcon;
module.exports = exports['default'];